package com.abmcode.bpmsample.entity;

import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;

import javax.persistence.*;
import java.time.LocalDateTime;
import java.util.Date;
import java.util.UUID;

@JmixEntity
@Table(name = "BPMSPL_LEAVE_APPLICATION", indexes = {
        @Index(name = "IDX_BPMSPLLEAVEAPPLIC_EMPLOYEE", columnList = "EMPLOYEE_ID"),
        @Index(name = "IDX_BPMSPLLEAVEAPPLIC_APPROVAL", columnList = "APPROVAL_ID")
})
@Entity(name = "bpmspl_LeaveApplication")
public class LeaveApplication {
    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private UUID id;

    @InstanceName
    @Column(name = "DESCRIPTION")
    private String description;

    @Column(name = "FROM_")
    private LocalDateTime from;

    @Column(name = "TO_")
    private LocalDateTime to;

    @JoinColumn(name = "EMPLOYEE_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private User employee;

    @Column(name = "STATUS")
    private String status;

    @Column(name = "COMMENTS")
    private String comments;

    @JoinColumn(name = "APPROVAL_ID")
    @ManyToOne(fetch = FetchType.LAZY)
    private User approval;

    @CreatedBy
    @Column(name = "CREATED_BY")
    private String createdBy;

    @CreatedDate
    @Column(name = "CREATED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date createdDate;

    @LastModifiedBy
    @Column(name = "LAST_MODIFIED_BY")
    private String lastModifiedBy;

    @LastModifiedDate
    @Column(name = "LAST_MODIFIED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date lastModifiedDate;

    public String getComments() {
        return comments;
    }

    public void setComments(String comments) {
        this.comments = comments;
    }

    public LeaveAppStatus getStatus() {
        return status == null ? null : LeaveAppStatus.fromId(status);
    }

    public void setStatus(LeaveAppStatus status) {
        this.status = status == null ? null : status.getId();
    }

    public void setFrom(LocalDateTime from) {
        this.from = from;
    }

    public LocalDateTime getFrom() {
        return from;
    }

    public void setTo(LocalDateTime to) {
        this.to = to;
    }

    public LocalDateTime getTo() {
        return to;
    }

    public User getApproval() {
        return approval;
    }

    public void setApproval(User approval) {
        this.approval = approval;
    }

    public User getEmployee() {
        return employee;
    }

    public void setEmployee(User employee) {
        this.employee = employee;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Date getLastModifiedDate() {
        return lastModifiedDate;
    }

    public void setLastModifiedDate(Date lastModifiedDate) {
        this.lastModifiedDate = lastModifiedDate;
    }

    public String getLastModifiedBy() {
        return lastModifiedBy;
    }

    public void setLastModifiedBy(String lastModifiedBy) {
        this.lastModifiedBy = lastModifiedBy;
    }

    public Date getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(Date createdDate) {
        this.createdDate = createdDate;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public UUID getId() {
        return id;
    }

    public void setId(UUID id) {
        this.id = id;
    }
}